package com.nisum.ascend.promotions.service;

import com.nisum.ascend.promotions.dto.PromotionDto;
import com.nisum.ascend.promotions.repository.PromotionRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import reactor.core.publisher.Flux;
import reactor.core.scheduler.Schedulers;

import java.util.List;

@Service
public class PromotionService {

    @Autowired
    PromotionRepository promotionRepository;

    public Flux<PromotionDto> findAll(){
        return promotionRepository.findAll().map(PromotionDto::generateDtoFromPromotion);
    }

    public Flux<PromotionDto> findPromotionsByProductSku(String sku){
        return promotionRepository.findByProductSku(sku).map(PromotionDto::generateDtoFromPromotion);
    }

    public Flux<PromotionDto> bulkSearchSKU(List<String> skus){

//        skus.stream().map(sku -> findPromotionsByProductSku(sku));

//        return Flux.fromStream(skus.stream().map(sku -> findPromotionsByProductSku(sku)));

        return null;

//        return Flux.fromIterable(skus)
//                .map(sku -> {
//                    return findPromotionsByProductSku(sku);
//                });
    }

}
